#include "h/Chat.h"
#include "h/SkypeConnection.h"

#include "SkypeTest.h"

typedef StreamLogger<LvlTimeLogPrefix> MyLogger_t;
MyLogger_t logger(std::cout);
LogFunc_t lf(&logger, &MyLogger_t::Do);
using namespace Ice;

void DefaultCallback(const std::string& s)
{
	fprintf(stdout, "%s: '%s'\n", __FUNCTION__, s.c_str());	
};


//--- Tutorial example code ---
bool SearchResult(const std::vector<Chat*>& resp)
{
	std::cout << "Active chat search result:" << std::endl;
	typedef std::vector<Chat*>::const_iterator CI;
	for(CI p = resp.begin(); p != resp.end(); ++p) 
	{
		Chat& ch = **p;
		std::cout << "Chat '" << ch[chName] << "' with the members: '";
		std::cout << ch[chMembers] << "'" << std::endl;
	};
	return false;
};
//--- End of tutorial example code ---

int main(int argc, char* argv[])
{
//    SkypeConnection sk(argv[0], SimpleHandler_t(DefaultCallback), lf);
    SkypeConnection sk(argv[0], SimpleHandler_t(DefaultCallback));
    sk.Attach();
    sk << DisableIds << "PROTOCOL 99" << flush << EnableIds;
	ChatManager chm(sk, sk.GetLog());

	std::cout << "***** Please open some chat window in Skype, after that press <Enter>";
	char tmp;
	std::cin.read(&tmp, sizeof(tmp));

//--- Tutorial example code ---
	// The same as: std::set<ChatAttrs_t> attrs;
	ChatManager::AttrSet_t attrs;
	attrs.insert(chMembers);
	attrs.insert(chName);
	chm.Search(srActiveChats, SearchResult, attrs);
//--- End of tutorial example code ---

	const boost::posix_time::seconds tm(1);
	ProcessSkypeMsgs(sk, tm);

	return 0;
}
